<?php
function unitrack_tracker() {
  $args = func_get_args();
  $op = empty($args[0]) ? 'track' : $args[0];
  
  switch ($op) {
    case 'nojs.png':
      drupal_add_http_header('Content-Type', 'image/png');
      echo file_get_contents(drupal_get_path('module', 'unitrack') . '/nojs.png');
      $fout = fopen('/tmp/unitrack', 'a');
      fwrite($fout, time() . ' ' . print_r($_SERVER, 1) . print_r($_SESSION, 1) . print_r($_REQUEST, 1) . "\r\n");
      fclose($fout);
      return;
      break;
    case 'action':
    default:
      $q = db_query('SELECT * FROM {unitrack_events}');
      $tracked_events = array();
      foreach ($q as $row)
        $tracked_events[$row->event_id][] = $row->type_id;
      }
     
      $visitor_id = 0;
      $out = array();
      $existing = '';      // Retrieve user data if present.
      if (!empty($_REQUEST['vid'])) {
        $splitted = explode(',', $_REQUEST['vid']);
        if (count($splitted) == 2) {
          $visitor_id = intval($splitted[0]);
          if ($visitor_id > 0) {
            $existing = db_select('unitrack_visitors', 'v')
              ->fields('v', array('uuid'))
              ->condition('vid', $visitor_id)
              ->execute()
              ->fetchField();
          }
          if ($existing != $splitted[1]) {
            $visitor_id = 0;
            $existing == '';
          }
        }
      }      
      if ($visitor_id <= 0) {
        list($visitor_id, $vuuid) = unitrack_new_visitor();
        $out['visitor'] = $visitor_id . ',' . $vuuid;
      }
      $session_id = 0; // Retrieve session data if present.
      if (!empty($_REQUEST['sid'])) {
        $splitted = explode(',', $_REQUEST['sid']);
        if (count($splitted) == 2) {
          $session_id = intval($splitted[0]);
          if ($session_id > 0) {
            $existing = db_select('unitrack_sessions', 's')
              ->fields('s', array('uuid'))
              ->condition('sid', $session_id)
              ->execute()
              ->fetchField();
          }
          if ($existing != $splitted[1]) {
            $existing == '';
            $session_id = 0;
          }
          else {
            db_update('unitrack_sessions', 's')
              ->fields(array('visit_end' => REQUEST_TIME))
              ->condition('sid', $session_id)
              ->execute();
          }
        }
      }
      if ($session_id <= 0) {
        list($session_id, $suuid) = unitrack_new_session($visitor_id, $_POST);
        $out['session'] = $session_id . ',' . $suuid;
      }
      $out['tracked_events'] = $tracked_events;
      $additions = module_invoke_all('unitrack', $out);
      $out += $additions;
      _unitrack_session_data($out);
      drupal_json_output($out);
      db_insert('unitrack_actions')
        ->fields(array(
          'visit_id' => $session_id,
          'type' => 'Page View',
          'address' => $_REQUEST['path'],
          'timestamp' => REQUEST_TIME,
        ))
        ->execute();
  
  
  $workers_loaded = $_SESSION['unitrack_loaders'];
  $defaults = array(
    'workers' => array('self'),
  );
}

function unitrack_generate_uuid() {
  // The field names refer to RFC 4122 section 4.1.2.
  $uuid = sprintf('%04x%04x-%04x-4%03x-%04x-%04x%04x%04x', 
    mt_rand(0, 65535), mt_rand(0, 65535), // 32 bits for "time_low"
    mt_rand(0, 65535), // 16 bits for "time_mid"
    mt_rand(0, 4095),  // 12 bits before the 0100 of (version) 4 for "time_hi_and_version"
    bindec(substr_replace(sprintf('%016b', mt_rand(0, 65535)),'01', 6, 2)), // 8 bits, the last two of which (positions 6 and 7) are 01, for "clk_seq_hi_res"
    // (hence, the 2nd hex digit after the 3rd hyphen can only be 1, 5, 9 or d)
    // 8 bits for "clk_seq_low"
    mt_rand(0, 65535), mt_rand(0, 65535), mt_rand(0, 65535) // 48 bits for "node"
    );
  return $uuid; 
}

function unitrack_new_visitor() {
  $uuid = unitrack_generate_uuid();
  $vid = db_insert('unitrack_visitors')->fields(array('uuid' => $uuid, 'created' => 'NOW()'))->execute();
  return array($vid, $uuid);
}

function unitrack_new_session($visitor_id, $data) {
  $uuid = unitrack_generate_uuid();
  $data['user_agent'] = isset($data['ua']) ? substr($data['ua'],0,250) : 'unknown';
  unset($data['ua']);
  $data['resolution'] = isset($data['resolution']) ? $data['resolution'] : 'unknown';
  $data['os'] = isset($data['os']) ? $data['os'] : 'unknown';
  $data['flash_version'] = isset($data['flash_version']) ? $data['flash_version'] : 'unknown';
  $data['js_enabled'] = isset($data['js_enabled']) ? intval($data['js_enabled']) : (-1);
  $data['java_enabled'] = isset($data['java_enabled']) ? intval($data['java_enabled']) : (-1);
  if (key_exists('HTTP_X_REAL_IP', $_SERVER)) {
    $ip = $_SERVER['HTTP_X_REAL_IP'];
  } elseif (key_exists('HTTP_X_FORWARDED_FOR', $_SERVER)) {
    $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
  } elseif(isset($_SERVER['REMOTE_ADDR'])) {
    $ip = $_SERVER['REMOTE_ADDR'];
  }
  $data['ip'] = isset($data['ip']) ? $data['ip'] : $ip;
  $data['vid'] = $visitor_id;
  $data['uuid'] = $uuid;
  $data['visit_start'] = REQUEST_TIME;
  $data['visit_end'] = REQUEST_TIME;
  $sid = db_insert('unitrack_sessions')
    ->fields($data)
    ->execute();
  return array($sid, $uuid);
}